local battle = {};
local monster = require "monster";

local player = {};
local enemy = {hp = 0, atk = 0, def = 0, x = 0, y = 0};

local results = {[-1] = "enemy cannot be hurt",
                 [1] = "enemy dead",
                 [2] = "player dead"};
               
local turn = 0;

function battle.enemy_pos()
    return enemy.x, enemy.y;
end

function battle.get_enemy()
  return enemy;
end

function battle.turn()
  return turn;
end

--starts battle by setting the player and enemy stats to the right values
--we also should know the positions of the player and enemy
function battle.start(pl, en, en_x, en_y)
--  for stat, val in pairs(pl) do
--    player[stat] = val;
--    print("player "..stat..": "..val);
--  end
  player = pl;
  for stat, val in pairs(monster.types[en]) do
    enemy[stat] = val;
    print("enemy "..stat..": "..val);
  end
  enemy.x = en_x;
  enemy.y = en_y;
--  local result = {};
--  local outcome = battle.proceed(result);
--  print(results[outcome]);
--  result.outcome = outcome;
--  battle.over(outcome);
--  return result;
end

--right now just checks who dies
--later it should progress the battle
function battle.proceed(result)
  local num_turns = math.ceil(enemy.hp / (player.atk - enemy.def));
  print(num_turns);
  if(enemy.def >= player.atk) then
    return -1;
  else
    local player_damage = (player.atk - enemy.def) * num_turns;
    print("player damage: "..player_damage);
    local enemy_damage = (enemy.atk - player.def) * num_turns;
    print("enemy damage: "..enemy_damage);
    if(player_damage >= enemy.hp) then
      if(enemy_damage >= 0) then
        result.hploss = enemy_damage;
      else
        result.hploss = 0;
      end
      return 1;
    end
    if(enemy_damage >= player.hp) then
      return 2;
    end
  end
end

function battle.step()
  print("battle step");
  local result = 0;
  if (turn == 0) then
    if(enemy.def <= player.atk) then
      enemy.hp = enemy.hp - (player.atk - enemy.def);
    end
    turn = 1;
  elseif (turn == 1) then
    if(player.def <= enemy.atk) then
      player.hp = player.hp - (enemy.atk - player.def);
    end
    turn = 0;
  end
  if (enemy.hp <= 0) then
    result = 1;
    turn = 0;
  end
  return result;
end

function battle.over(outcome)

end

return battle;
